<script setup lang="ts">
import { useAuthStore } from '@/stores/auth'
import { useBillCostStore } from '@/stores/billcost'
import { useTypebillcostStore } from '@/stores/typebillcost'
import { useBranchStore } from '@/stores/branch'
import { useUserStore } from '@/stores/user'
import { computed, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import Swal from 'sweetalert2'

const typebillcostStore = useTypebillcostStore()
const branchStore = useBranchStore()
const billcostStore = useBillCostStore()
const UserStore = useUserStore()
const form = ref(false)
const loading = ref(false)
const authStore = useAuthStore()
const refform = ref<VForm | null>(null)
const notypebillcost = ref(false)
const nototal = ref(false)
const nouser = ref(false)
const nobranch = ref(false)
const noall = ref(false)

const currentUser = computed(() => authStore.getCurrentUser())
const filteredBranches = computed(() => {
  const allUsers = UserStore.users
  if (!currentUser.value) {
    // หาข้อมูลผู้ใช้ปัจจุบัน
    return null
  }
  const currentUserData = allUsers.find((user) => user.id === currentUser.value?.id)
  if (!currentUserData) {
    // ตรวจสอบว่าพบข้อมูลผู้ใช้ปัจจุบันหรือไม่
    return null
  }
  return currentUserData.branch // คืนค่า branch ของผู้ใช้ปัจจุบัน
})

const validateBillcostTotal = (v: number) => {
  if (v === null) return 'Field is required '
  const num = Number(v)
  return (Number.isFinite(num) && num > 0) || 'Number must be more than 0'
}

onMounted(async () => {
  await UserStore.getUsers()
  await branchStore.getBranchs()
})

const save = () => {
  if (
    !billcostStore.editedbillCost.typebillcost &&
    billcostStore.editedbillCost.billtotal <= 0 &&
    !billcostStore.editedbillCost.user &&
    !billcostStore.editedbillCost.branch
  ) {
    noall.value = true
  } else if (!billcostStore.editedbillCost.typebillcost) {
    notypebillcost.value = true
  } else if (!billcostStore.editedbillCost.user) {
    nouser.value = true
  } else if (billcostStore.editedbillCost.billtotal <= 0) {
    nototal.value = true
  } else if (!billcostStore.editedbillCost.branch) {
    nobranch.value = true
  } else if (
    billcostStore.editedbillCost.typebillcost &&
    billcostStore.editedbillCost.billtotal > 0 &&
    billcostStore.editedbillCost.user &&
    billcostStore.editedbillCost.branch
  ) {
    billcostStore.savebillcost()
    billcostStore.closeDialog()
  }
}
</script>
<template>
  <v-row justify="center">
    <v-dialog v-model="billcostStore.dialog" persistent width="800">
      <v-card style="border: black solid 2px; border-radius: 50px">
        <v-card-title style="margin-left: 30px; padding: 20px">
          <span class="text-h5">ADD BILL COST</span>
        </v-card-title>
        <v-card-text>
          <v-form ref="refform" v-model="form">
            <v-container>
              <v-row>
                <v-col>
                  <v-col cols="12" md="12" style="padding: 0">
                    <v-combobox
                      v-model="billcostStore.editedbillCost.typebillcost"
                      :items="typebillcostStore.typebillcosts"
                      item-title="name"
                      item-value="id"
                      label="TypeBill"
                      :return-object="true"
                      :rules="[(v) => !!v || 'Field is required']"
                    ></v-combobox>
                  </v-col>

                  <v-col cols="12" md="12" style="padding: 0">
                    <v-combobox
                      v-model="billcostStore.editedbillCost.user"
                      :items="[authStore.getCurrentUser()]"
                      item-title="fullName"
                      item-value="id"
                      label="User"
                      :rules="[(v) => !!v || 'Field is required']"
                    ></v-combobox>
                  </v-col>

                  <v-col cols="12" md="12" style="padding: 0">
                    <v-text-field
                      v-model="billcostStore.editedbillCost.billtotal"
                      :readonly="loading"
                      :rules="[validateBillcostTotal]"
                      class="mb-2"
                      clearable
                      label="Total"
                    ></v-text-field>
                  </v-col>

                  <v-col cols="12" md="12" style="padding: 0">
                    <v-combobox
                      v-model="billcostStore.editedbillCost.branch"
                      :items="[authStore.getCurrentUser()?.branch]"
                      item-title="Address"
                      item-value="id"
                      label="Branch"
                      :return-object="true"
                      :rules="[(v) => !!v || 'Field is required']"
                    ></v-combobox>
                  </v-col>
                </v-col>
                <v-divider :thickness="2" class="border-opacity-100" vertical></v-divider>
                <v-col>
                  <v-col cols="12" md="6" offset-md="3">
                    <v-img
                      :src="
                        'http://localhost:3000/images/billcosts/' +
                        billcostStore.editedbillCost.image
                      "
                      height="200"
                      width="200"
                    ></v-img>
                  </v-col>
                  <v-col cols="12" md="12" style="padding: 0">
                    <v-file-input
                      v-model="billcostStore.editedbillCost.files"
                      :rules="[
                        (value) => {
                          return (
                            !value ||
                            !value.length ||
                            value[0].size < 2000000 ||
                            'Avatar size should be less than 2 MB!'
                          )
                        }
                      ]"
                      accept="image/png, image/jpeg"
                      label="Avatar"
                      placeholder="Pick an avatar"
                      prepend-icon="mdi-image-multiple"
                    >
                    </v-file-input>
                  </v-col>
                </v-col>
              </v-row>
            </v-container>
          </v-form>
          <small>*indicates required field</small>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue-darken-1" variant="text" @click="billcostStore.closeDialog()">
            Close
          </v-btn>
          <v-btn color="blue-darken-1" variant="text" @click="save()" style="margin-right: 30px">
            Save
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
  <!-- เงิน -->
  <template>
    <v-dialog v-model="nototal" width="250">
      <template v-slot:default="{ isActive }">
        <v-card title="Warning" style="border: #fe0000 solid 2px; border-radius: 20px">
          <v-card-text> Please enter the amount.</v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>

            <v-btn text="Close" color="red" @click="isActive.value = false"></v-btn>
          </v-card-actions>
        </v-card>
      </template>
    </v-dialog>
    <v-dialog v-model="nouser" width="250">
      <template v-slot:default="{ isActive }">
        <v-card title="Warning" style="border: #fe0000 solid 2px; border-radius: 20px">
          <v-card-text> Please enter User. </v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>

            <v-btn text="Close" color="red" @click="isActive.value = false"></v-btn>
          </v-card-actions>
        </v-card>
      </template>
    </v-dialog>
    <v-dialog v-model="nobranch" width="250">
      <template v-slot:default="{ isActive }">
        <v-card title="Warning" style="border: #fe0000 solid 2px; border-radius: 20px">
          <v-card-text> Please enter Branch. </v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>

            <v-btn text="Close" color="red" @click="isActive.value = false"></v-btn>
          </v-card-actions>
        </v-card>
      </template>
    </v-dialog>
    <v-dialog v-model="noall" width="300">
      <template v-slot:default="{ isActive }">
        <v-card title="Warning" style="border: #fe0000 solid 2px; border-radius: 20px">
          <v-card-text> Please enter Field is required. </v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>

            <v-btn text="Close" color="red" @click="isActive.value = false"></v-btn>
          </v-card-actions>
        </v-card>
      </template>
    </v-dialog>
    <v-dialog v-model="notypebillcost" width="300">
      <template v-slot:default="{ isActive }">
        <v-card title="Warning" style="border: #fe0000 solid 2px; border-radius: 20px">
          <v-card-text> Please enter Typebillcost. </v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>

            <v-btn text="Close" color="red" @click="isActive.value = false"></v-btn>
          </v-card-actions>
        </v-card>
      </template>
    </v-dialog>
  </template>
</template>
